USE AdventureWorksDWDenali
GO

-- old approach using OVER clause

SELECT rs.ProductKey, rs.OrderDateKey, rs.SalesOrderNumber,
rs.OrderDateKey-(SELECT TOP(1)prev.OrderDateKey
FROM dbo.FactResellerSales AS prev
WHERE rs.ProductKey=prev.ProductKey
AND prev.OrderDateKey <= rs.OrderDateKey
AND prev.SalesOrderNumber <rs.SalesOrderNumber
ORDER BY prev.OrderDateKey DESC,
prev.SalesOrderNumber DESC)
AS DaysSincePrevOrder
FROM dbo.FactResellerSales AS rs
ORDER BY rs.ProductKey,rs.OrderDateKey,rs.SalesOrderNumber;


-- new approach using LAG function

SELECT ProductKey, OrderDateKey, SalesOrderNumber,
OrderDateKey-LAG(OrderDateKey)
OVER (PARTITION BY ProductKey
ORDER BY OrderDateKey, SalesOrderNumber)
AS DaysSincePrevOrder
FROM dbo.FactResellerSales AS rs
ORDER BY ProductKey,OrderDateKey,SalesOrderNumber;
